﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace SnakeOnAPhone
{
    public partial class MainPage : PhoneApplicationPage
    {
        const Int32 GridSize = 15;
        snake S;
        private System.Windows.Threading.DispatcherTimer timer = new System.Windows.Threading.DispatcherTimer();
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            for (int i = 0; i < GridSize; i++)
            {
                PlayArea.ColumnDefinitions.Add(new ColumnDefinition());
                PlayArea.RowDefinitions.Add(new RowDefinition());
            }
             S = new snake(PlayArea);
             setupTimer();
             timer.Start();
        }

        private void setupTimer() 
        { 
            timer.Interval = new TimeSpan(0, 0, 0, 0, 100);
            timer.Tick += (obj, evnt) => { S.UpdateSnake(); }; 
        }
      
        
       

    }
    
    class snake
    {
        private Point head = new Point(5, 5);
        private Grid _grid;
        private Int32 GridSize;
        private Int32 Len = 6;
     
        private Queue<Ellipse> Positions = new Queue<Ellipse>();
       
        private Point velocity = new Point(1, 0);
        private  Random R = new Random();
        public snake(Grid grid)
        {
            GridSize = grid.ColumnDefinitions.Count();

            _grid = grid;
            for (Int32 i = 0; i < Len; i++)
            {
                addHead(new Point(5 + i, 5));
            }

        }

        private void addHead(Point head)
        {
            Ellipse el = new Ellipse();
            el.Fill = new SolidColorBrush(Colors.Red);
            Grid.SetColumn(el, (Int32)head.X);
            Grid.SetRow(el, (Int32)head.Y);
            _grid.Children.Add(el);
            Positions.Enqueue(el);

        }
        public void UpdateSnake()
        {
            head.X = (head.X + velocity.X + GridSize) % GridSize;
            head.Y = (head.Y + velocity.Y + GridSize) % GridSize;
            if (R.NextDouble() < 0.1) turnRight();
            if (R.NextDouble() < 0.1) turnLeft();

            addHead(head);
            if (R.NextDouble() > 0.01) removeOldTail();

        }
        private void turnRight()
        {
            double t = velocity.Y;
            velocity.Y = -velocity.X;
            velocity.X = t;

        }
        private void turnLeft()
        {
            double t = velocity.Y;
            velocity.Y = velocity.X;
            velocity.X = -t;
        }
        private void removeOldTail()
        {

            Ellipse Tail = Positions.Dequeue();
            Tail.Visibility = Visibility.Collapsed;

        }
    }
}
